SystemOrganization addCategory: #MetaProgramacion!

Object subclass: #MissingImplementorsFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaProgramacion'!

!MissingImplementorsFinder class methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 6/19/2013 21:41'!
class: aClass implements: aSelector
	^ aClass methodDictionary at: aSelector ifPresent: [:anAssoc | (anAssoc value isAbstract) not ] ifAbsent: [ false ]! !

!MissingImplementorsFinder class methodsFor: 'enumerating' stamp: 'EtchegoyenLajePulver 6/19/2013 21:37'!
hierarchyFrom: aLeafClass Until: aParentClass implements: aSelector
	(self class: aLeafClass implements: aSelector) ifTrue: [ ^ true ].
	^ aLeafClass = aParentClass ifTrue: [  false ]
	ifFalse: [ self hierarchyFrom: aLeafClass superclass Until: aParentClass implements: aSelector ].! !

!MissingImplementorsFinder class methodsFor: 'enumerating' stamp: 'EtchegoyenLajePulver 6/19/2013 21:43'!
searchByMethod: aCompiledMethod 
	| aClass leaves implementors |
	aCompiledMethod isAbstract ifFalse: [ ^ Set new ].
	
	aClass := aCompiledMethod classBinding value.
	
	leaves := aClass allSubclasses select: [:aSubClass | aSubClass subclasses isEmpty ].
	
	leaves := leaves select: [:aLeaf | (self hierarchyFrom: aLeaf Until: aClass implements: aCompiledMethod selector) not ].
	
	^ leaves! !

Object subclass: #TestParentClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaProgramacion'!

!TestParentClass class methodsFor: 'enumerating' stamp: 'EtchegoyenLajePulver 6/19/2013 20:14'!
anAbstractMethodNotImplemented
	^ self subclassResponsibility! !

!TestParentClass methodsFor: 'implemented methods' stamp: 'EtchegoyenLajePulver 6/19/2013 20:02'!
aNonAbstractMethod
	^ true! !

!TestParentClass methodsFor: 'implemented methods' stamp: 'EtchegoyenLajePulver 6/19/2013 20:16'!
anAbstractMethodNotImplemented
	^ self subclassResponsibility ! !

TestParentClass subclass: #TestSubClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaProgramacion'!

TestCase subclass: #MetaProgramacionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaProgramacion'!

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/19/2013 20:03'!
aNonAbstractMethod
	^ self aTestParentClass methodDictionary at: #aNonAbstractMethod! !

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/19/2013 20:01'!
aTestParentClass
	^ TestParentClass! !

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/19/2013 20:46'!
aTestSubClass
	^ TestSubClass! !

!MetaProgramacionTest methodsFor: 'test classes and methods' stamp: 'EtchegoyenLajePulver 6/19/2013 20:15'!
anAbstractMethodNotImplemented
	^ self aTestParentClass methodDictionary at: #anAbstractMethodNotImplemented! !

!MetaProgramacionTest methodsFor: 'tests' stamp: 'EtchegoyenLajePulver 6/19/2013 20:06'!
test01NonAbstractMethodReturnsEmpty
	| aCollection |
	aCollection := MissingImplementorsFinder searchByMethod: self aNonAbstractMethod.
	self assert: aCollection isEmpty! !

!MetaProgramacionTest methodsFor: 'tests' stamp: 'EtchegoyenLajePulver 6/19/2013 20:11'!
test02AbstractMethodNotImplementedInSubclassesDoesntReturnEmpty
	| aCollection |
	aCollection := MissingImplementorsFinder searchByMethod: self anAbstractMethodNotImplemented.
	self deny: aCollection isEmpty! !

!MetaProgramacionTest methodsFor: 'tests' stamp: 'EtchegoyenLajePulver 6/19/2013 20:46'!
test03SearcinAbstractMethodNotImplementedInSubclassReturnsSubclass
	| aCollection |
	aCollection := MissingImplementorsFinder searchByMethod: self anAbstractMethodNotImplemented.
	self deny: aCollection isEmpty.
	self assert: (aCollection includes: self aTestSubClass)! !
